/*   Yacc Program #2
To check the validity of a parenthisized arithmetic expression                    */

%{
#include<stdio.h>
%}
%token DIGIT
%left '+' '-'
%left '*' '/'
%left '(' ')'
%nonassoc UMINUS
%%
expr : '(' expr ')'
     | expr '+' expr
     | expr '-' expr
     | expr '*' expr
     | expr '/' expr
     | '-' expr %prec UMINUS
     | number 
     ;
number : DIGIT
       | number DIGIT
         { $$=10*$1 +$2;}
       ;
%%
int yylex()
{
int c;
while((c=getchar())==' ');
if(c=='\n')
return(0);
if(isdigit(c))
{
yylval=c-'\0';
return(DIGIT);
}
return(c);
}
int yyerror()
{
printf("Invalid Expression\n");
}
int main()
{
printf("Enter an Arithmetic Expression : ");
if(!yyparse())
printf("Valid Expression\n");
}

/***************************************************************************
  OUTPUT
Enter an Arithmetic Expression : (5+(8*5)-8)
Valid Expression
*/
