/*    Yacc Program #5
To evaluate the given arithmetic expression                                 */

%{
#include<stdio.h>
%}
%token  DIGIT
%left  '^'
%left  '|'
%left  '&'
%left  '+' '-'
%left  '*' '/'
%nonassoc  UMINUS
%%
s : expr
     {printf("Value of Expression : %d\n",$1);}
expr : '(' expr ')'
        {$$ = $2;}
     | expr '+' expr
        {$$=$1 + $3;}
     | expr '-' expr
        {$$=$1 - $3;}
     | expr '*' expr
        {$$=$1 * $3;}
     | expr '/' expr
        {if($3==0){
          printf("Attempt to divide by ZERO\n");
          exit(-2);}
         else
          $$=$1/$3;}
     | expr '|' expr
        {$$=$1 | $3;}
     | expr '&' expr
        {$$=$1 & $3;}
     | expr '^' expr
        {$$=$1 ^ $3;}
     | '!' expr%prec UMINUS
        {$$ = !$2;}
     | '-' expr%prec  UMINUS
        {$$ = -$2;}
     | number
     ;
number : DIGIT
       | number DIGIT
          {$$= 10*$1 + $2;}
       ;
%%
int yylex()
{
int c;
while((c=getchar())==' ');
if(c=='\n')
return(0);
if(isdigit(c))
{
yylval=c-'0';
return(DIGIT);
}
return(c);
}
int yyerror()
{
printf("Invalid Expression\n");
exit(-1);
}
int main()
{
printf("Enter an Arithmetic Expression : ");
yyparse();
}

/*****************************************************************************
 OUTPUT
Enter an Arithmetic Expression : (1+(2*3))
Value of Expression : 7
*/